Skip to content

Latest commit

 

History

History

2379

Folders and files

NameName
Last commit message
Last commit date

parent directory

..
 
 

You are given a 0-indexed string blocks of length n, where blocks[i] is either 'W' or 'B', representing the color of the ith block. The characters 'W' and 'B' denote the colors white and black, respectively.

You are also given an integer k, which is the desired number of consecutive black blocks.

In one operation, you can recolor a white block such that it becomes a black block.

Return the minimum number of operations needed such that there is at least one occurrence of k consecutive black blocks.

 

Example 1:

Input: blocks = "WBBWWBBWBW", k = 7
Output: 3
Explanation:
One way to achieve 7 consecutive black blocks is to recolor the 0th, 3rd, and 4th blocks
so that blocks = "BBBBBBBWBW". 
It can be shown that there is no way to achieve 7 consecutive black blocks in less than 3 operations.
Therefore, we return 3.

Example 2:

Input: blocks = "WBWBBBW", k = 2
Output: 0
Explanation:
No changes need to be made, since 2 consecutive black blocks already exist.
Therefore, we return 0.

 

Constraints:

  • n == blocks.length
  • 1 <= n <= 100
  • blocks[i] is either 'W' or 'B'.
  • 1 <= k <= n

Companies: DailyHunt

Related Topics:
String, Sliding Window

Similar Questions:

Solution 1. Fixed-length Sliding Window

// OJ: https://leetcode.com/problems/minimum-recolors-to-get-k-consecutive-black-blocks
// Author: github.com/lzl124631x
// Time: O(N)
// Space: O(1)
class Solution {
public:
    int minimumRecolors(string s, int k) {
        int cnt = 0, ans = INT_MAX;
        for (int i = 0, N = s.size(); i < N; ++i) {
            cnt += s[i] == 'W';
            if (i - k >= 0) cnt -= s[i - k] == 'W';
            if (i >= k - 1) ans = min(ans, cnt);
        }
        return ans;
    }
};